"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _readmodelBase = require("@resolve-js/readmodel-base");

const status = async (pool, readModelName) => {
  var _ref;

  const state = await pool.getReplicationState(pool);
  let runStatus = _readmodelBase.ReadModelRunStatus.DELIVER;

  if (state.status === 'error') {
    runStatus = _readmodelBase.ReadModelRunStatus.ERROR;
  } else if (state.paused) {
    runStatus = _readmodelBase.ReadModelRunStatus.SKIP;
  }

  let error = null;

  if (state.status === 'error' || state.status === 'serviceError') {
    if (state.statusData == null) {
      error = {
        message: 'Unknown error',
        name: 'Error'
      };
    } else {
      error = {
        name: state.statusData.name === undefined ? 'Error' : state.statusData.name,
        message: state.statusData.message,
        stack: state.statusData.stack === undefined ? state.statusData.message : state.statusData.stack
      };
    }
  }

  const result = {
    eventSubscriber: readModelName,
    deliveryStrategy: 'inline-ledger',
    successEvent: state.successEvent != null ? state.successEvent : {
      type: 'Init'
    },
    failedEvent: null,
    errors: error != null ? [error] : null,
    cursor: state.iterator ? (_ref = state.iterator.cursor) !== null && _ref !== void 0 ? _ref : null : null,
    status: runStatus
  };
  return result;
};

var _default = status;
exports.default = _default;
//# sourceMappingURL=status.js.map